﻿
//--- index.js implementiert HTML-Menüs für ePubs
//--- 2012 Thilo Brai
//--- index.js ist frei für nichtkommerzielle Nutzung

//--- index.js wird geladen, wenn der Server mit der Option -onload gestartet wurde.
//--- index.js sollte die function "OnLoad ()" enthalten.
//--- OnLoad () wird aufgerufen, nachdem der Browser eine eBooks-XML-Datei eingelesen hat.
//--- In OnLoad () kann z. B. ein Menü auf der HTML/XML-Datei installiert werden,
//--- das per Ajax-Call mit den Infos zu /index.html geladen wird.

var menuStr
= "<div id='menu' style='position:fixed; top:0px; right:0px; max-height:95%; text-align:right; overflow:auto;'>"
+       "<a href='javascript:void(togglePopup())' style='text-decoration:none; background-color:#FFEEEE;'>M</a>"
//--- Das Popup-Menü
+ "<div id='popup' style='display:none; text-align:left; background-Color:#AAAAAA; border:1px solid black;'>"
+    "<div style='text-align:center;'>"

+    "<nobr>"
+    "<a href='javascript:void(getAndInstallBooksIndex())' id='uiBuecher'                                          >Bücher</a> | " 
+    "<a href='javascript:void(getAndInstallBookIndex())'  id='uiInhalt' style='text-decoration:none; cursor:text;'>Inhalt</a> | "
//+  "Kapitel: <span id='mmenuPrev'>&nbsp;&lt;&nbsp;</span> <span id='mmenuNext'>&nbsp;&gt;&nbsp;</span> | "
+    "<a href='javascript:void(installInfo())' id='uiBedien'>&nbsp;Bedienung&nbsp;</a> | " 
+    "<a href='javascript:void(toggleNeg())'>Invert.</a>"
+    "</nobr><hr />"

+       "<div id='menuInhalt' style='text-align:left; margin:8px; '>"
+           "-leer-"
+       "</div>"
+    "</div>"	// Dateien blättern center
+ "</div>"	// id popup
+ "</div>"	// id menu
//--- Wenn der Button für die nächste Datei ganz unten sitzt, ist er schwer
//--- erreichbar, wenn der Browser keine Statuszeile hat und kein Scroller
//--- eingeblendet ist. evtl bottom:0px auf 16px ändern.
//--- vorige Datei
+ "<div id='menuPrev' style='position:fixed; left:0px; bottom:0px; background-Color:#F8F8F8;'>"
+ "&lt;"
+ "</div>"
//--- nächste Datei
+ "<div id='menuNext' style='position:fixed; right:0px; bottom:0px; background-Color:#F8F8F8;'>"
+ "&gt;"
+ "</div>"
;


function OnLoad ()
{
	//alert ("Onload () is called.");
	var div = document.createElement ("div");
	document.body.appendChild (div);
	div.innerHTML = menuStr;

	glBuchInhalt = "";
	glBuecherInhalt = "";

	var linkT1 = "<a style='text-decoration:none; background-color:#FFEEEE' href='" 	//"<a href='";
	var linklt = "'>&lt;</a>" 	//"'>&nbsp;&lt;&nbsp;</a>"
	var linkgt = "'>&gt;</a>" 	//

	//--- Eine Datei zurück blättern
	if (webBookPrevFile.length) {
		div = document.getElementById ("menuPrev");
		if (div)
			div.innerHTML = linkT1 + webBookPrevFile + linklt;
		div = document.getElementById ("mmenuPrev");
		if (div)
			div.innerHTML = linkT1 + webBookPrevFile + linklt;
	}

	//--- Eine Datei weiter blättern
	if (webBookNextFile.length) {
		div = document.getElementById ("menuNext");
		if (div)
			div.innerHTML = linkT1 + webBookNextFile + linkgt;
		div = document.getElementById ("mmenuNext");
		if (div)
			div.innerHTML = linkT1 + webBookNextFile + linkgt;
	}

	getAndInstallBookIndex ();	// Verzeichnis des Buchs
	//getAndInstallBooksIndex ();	// Verzeichnis der Bücher

	//--- OnKeyDown () einrichten
	document.onkeydown = OnKeyDown;
}

//--- Eventhandler für Tastendrücke
//--- Taste M: Menü ein/ausblenden
//--- Pfeil links: zur vorigen Datei
//--- Pfeil rechts: zur nächsten Datei
//--- Pfeil hoch: nach oben scrollen
//--- Pfeil unten: nach unten scrollen
function OnKeyDown (Event)
{
	if (!Event)
		Event = window.event;
	var Tastencode = 0;
	if (Event.which)
		Tastencode = Event.which;
	else if (Event.keyCode)
		Tastencode = Event.keyCode;

	switch (Tastencode) {	// z = 90, w = 87
		case 37: if (webBookPrevFile.length)	// Pfeil links
					window.location.href = webBookPrevFile;
			break;
		case 39: if (webBookNextFile.length)	// Pfeil rechts
					window.location.href = webBookNextFile;
			break;
		case 38: 	// Pfeil rauf
			break;
		case 40: 	// Pfeil runter
			break;
		case 77: togglePopup ();	// m
			break;
	}
}

//--- Popup-Menü ein-/ausblenden
function togglePopup ()
{
	var popup = document.getElementById ("popup");
	if (popup)
		popup.style.display = (popup.style.display.toLowerCase () == "block")
			? "none" : "block";
}

//--- Hintergrund schwarz oder weiß machen
function toggleNeg ()
{
	var bk = document.body.style.backgroundColor;
	if (!bk.length) {
		document.body.style.backgroundColor = "black";
		document.body.style.color = "white";
		set_p_style_color ("white");	// wg. color: black; in css
	} else {
		document.body.style.backgroundColor = "";
		document.body.style.color = "";
		set_p_style_color ("");
	}
}

function set_p_style_color (color)
{
	var ps = document.getElementsByTagName ("p");
	for (var i = 0; i < ps.length; i++)
		ps [i].style.color = color;
}

function menuBold (element, bold)
{
	if (!element)
		return;
	element.style.cursor         = bold ? "text" : "pointer";
	element.style.fontWeight     = bold ? "bold" : "normal";
	element.style.textDecoration = bold ? "none" : "underline";
}

//--- Neu in Version 0.4 sind zusätzliche Buttons im Popup-Menü 
//--- zum Vergrößeren/Verkleinern und für voriges/nächstes Kapitel
function installInfo ()
{
	var inhalt = document.getElementById ("menuInhalt");
	if (inhalt) {
		inhalt.innerHTML = "<table><tr>"
		+ "<td><b>Tastaturbefehle:</b>   </td><td>						</td></tr><tr>"
		+ '<td>Textgröße ändern:         </td><td><input type="button" value="Strg +"	onclick="if(window.parent.document.body.style.zoom!=0) window.parent.document.body.style.zoom*=1.2; else window.parent.document.body.style.zoom=1.2;">/<input type="button" value="Strg -" onclick="if(window.parent.document.body.style.zoom!=0) window.parent.document.body.style.zoom*=0.8; else window.parent.document.body.style.zoom=0.8;"></td></tr><tr>'
		+ "<td>Kapitelanfang/-ende:      </td><td>Pos1/Ende			</td></tr>"
		+ '<td>Menü öffnen/schließen:    </td><td><input type="button" value="Taste M" onclick="togglePopup()"></td></tr><tr>'
		+ "<td>Ein paar Zeilen scrollen: </td><td>Pfeil rauf/runter	</td></tr><tr>"
		+ "<td>Eine Seite scrollen:      </td><td>Bild rauf/runter	</td></tr><tr>"
		+ '<td>Voriges/nächstes Kapitel: </td><td><input type="button" value="Pfeil ←" onclick="if(webBookPrevFile.length) window.location.href=webBookPrevFile">/<input type="button" value="Pfeil →" onclick="if(webBookNextFile.length) window.location.href=webBookNextFile"></td></tr><tr>'
		//+ "<td>Lesezeichen setzen: n. V."
		+ "</table>";
		menuBold (document.getElementById ("uiBuecher"), 0);
		menuBold (document.getElementById ("uiInhalt" ), 0);
		menuBold (document.getElementById ("uiBedien" ), 1);
	}
	return false;
}

//--- Helper für getAndInstallBookIndex ()
function getXMLHttpRequest ()
{
	try {
		return new XMLHttpRequest();
	} catch (e) {
		try {
			return new ActiveXObject("Msxml2.XMLHTTP");
		} catch (nonms) {
			try{
				return new ActiveXObject ("Microsoft.XMLHTTP");
			} catch (failed){
				Report ("*** Kein XMLHttpRequest-Objekt erzeugt!");
			}
		}  
	}
	return null;
}

//--- Verzeichnis des Buchs einlesen
function getAndInstallBookIndex ()
{
	if (glBuchInhalt.length) {
		installBookIndex (glBuchInhalt);
		return;
	}
	var req = getXMLHttpRequest ();
	if (req) {
		//--- webBookRoot wird bei der Auslieferung von webPub initiallisiert
		//--- webPubMenuInfo = "../../../index.html";	//Report ("webPubMenuInfo: " + webBookRoot + "index.html");
		req.open ("GET", webBookRoot + "index.html", true);

		//--- Funktion installieren, die die Ajax-Antwort auswertet
		req.onreadystatechange = function () {
			switch (req.readyState) { //0 = uninitialized, 1 = loading, 2 = loaded, 3 = interactive, 4 = complete
			case 4: // == complete
				if (req.status == 0) {
					Report ("*** HTTP-Fehler status = uninitialized.");
				} else if (req.status != 200) {
					Report ("*** HTTP-Fehler: " + req.status); //12007 kein Internet
				} else {
					installBookIndex (req.responseText);
				}
				break;
			default:
				return false;
			}
		};
		//--- Absenden
		req.send (null);
	}
}

//--- Inhaltsverzeichnis des Buchs ins Menü eintragen
function installBookIndex (responseText)
{
	//--- einfache Version: einfach als Menü einfügen
	var inhalt = document.getElementById ("menuInhalt");
	if (!inhalt) {
		Report ("*** Fehler: popup.menuInhalt nicht vorhanden!");
		return false;
	}
	glBuchInhalt = responseText;
	//--- diese Ersetzung muss zu den Vorlagen in index.forms.html passen!
	//--- <a href...> korrigieren
	//--- <h2>%docAuthor%</h2> ausblenden
	//--- <h3>Inhalt</h3> ausblenden
	responseText = responseText.replace (/<a href="/ig, '<a href="' + webBookRoot)
					.replace ("<h2>", "<h2 style='display:none;'>")	// ausblenden
					.replace ("<h3>", "<h3 style='display:none;'>")	// ausblenden
					.replace ("<h1", "<h3").replace ("</h1>", "</h3>");	// kleiner
	inhalt.innerHTML = responseText;

	menuBold (document.getElementById ("uiBuecher"), 0);
	menuBold (document.getElementById ("uiInhalt" ), 1);
	menuBold (document.getElementById ("uiBedien" ), 0);
}


//--- Verzeichnis der verfügbaren Bücher einlesen
function getAndInstallBooksIndex ()
{
	if (glBuecherInhalt.length) {
		installBooksIndex (glBuecherInhalt);
		return;
	}
	var req = getXMLHttpRequest ();
	if (req) {
		//--- webPubRoot wird bei der Auslieferung von webPub initiallisiert
		//--- webPubMenuInfo = "../../../index.html";	//	Report ("webPubMenuInfo: " + webPubRoot + "index.html");
		req.open ("GET", webPubRoot + "index.html", true);

		//--- Funktion installieren, die die Ajax-Antwort auswertet
		req.onreadystatechange = function () {
			switch (req.readyState) { //0 = uninitialized, 1 = loading, 2 = loaded, 3 = interactive, 4 = complete
			case 4: // == complete
				if (req.status == 0) {
					Report ("*** HTTP-Fehler status = uninitialized.");
				} else if (req.status != 200) {
					Report ("*** HTTP-Fehler: " + req.status); //12007 kein Internet
				} else {
					installBooksIndex (req.responseText);
				}
				break;
			default:
				return false;
			}
		};
		//--- Absenden
		req.send (null);
	}
}

function installBooksIndex (responseText)
{
	//--- einfache Version: einfach als Menü einfügen
	var inhalt = document.getElementById ("menuInhalt");
	if (!inhalt) {
		Report ("*** Fehler: popup.menuInhalt nicht vorhanden!");
		return;
	}
	glBuecherInhalt = responseText;
	//--- diese Ersetzung muss zu den Links in index.html passen!
	responseText = responseText.replace (/<p><a href="/ig, '<p><a href="' + webPubRoot);
	inhalt.innerHTML = responseText;

	menuBold (document.getElementById ("uiBuecher"), 1);
	menuBold (document.getElementById ("uiInhalt" ), 0);
	menuBold (document.getElementById ("uiBedien" ), 0);
}


function hideReport ()
{
	var reporterDiv = document.getElementById ("int_report");
	if (reporterDiv)
		reporterDiv.style.display = "none";
}

function Report (s)
{
	var reporterDiv = document.getElementById ("int_report");
	if (!reporterDiv) {
		reporterDiv = document.createElement ("div");
		document.body.appendChild (reporterDiv);
		reporterDiv.style.position = "fixed";
		reporterDiv.style.right = "2em";	// Platz für den "nächste Seite Pfeil"
		reporterDiv.style.bottom = "0px";
		reporterDiv.style.backgroundColor = "#EEEEFF";
		//reporterDiv.style.color = "#FFFFFF";
	} else
		reporterDiv.style.display = "block";
	reporterDiv.innerHTML = s.replace (/&/g, '&amp;')
							.replace (/</g, '‹').replace (/>/g, '›');
	//--- nach 5 Sekunden wieder ausschalten
	window.setTimeout ("hideReport()", 5000);
}
